class Admin::SelectedCourseCategoriesController < OrbitMemberController
	
	def index
	end

	def new
		@selected_course_category = SelectedCourseCategory.new
		@url = admin_selected_course_categories_path
	end

	def edit
		@selected_course_category = SelectedCourseCategory.find(params[:id])
		@url = admin_selected_course_category_path(@selected_course_category)
	end

	def create
		selected_course_category = SelectedCourseCategory.create(selected_course_category_params)
		@selected_course_categories = SelectedCourseCategory.all.order_by(:sort_position => "asc")
	end

	def update
		selected_course_category = SelectedCourseCategory.find(params[:id]) rescue nil
		selected_course_category.update_attributes(selected_course_category_params) if !selected_course_category.nil?
		@selected_course_categories = SelectedCourseCategory.all.order_by(:sort_position => "asc")
	end

	def destroy
		selected_course_category = SelectedCourseCategory.find(params[:id]) rescue nil
		selected_course_category.destroy if !selected_course_category.nil?
		@selected_course_categories = SelectedCourseCategory.all.order_by(:sort_position => "asc")
	end

	def update_order
		orders = params["order"]
	    SelectedCourseCategory.each do |cc|
	      cc.sort_position = orders["#{cc.id}"]
	      cc.save
	    end
	    render :json => {"success" => true}.to_json
	end

	private 

	def selected_course_category_params
		params.require(:selected_course_category).permit!
	end
end